package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdatePortLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdatePortLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdatePortLogic {
	return &UpdatePortLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdatePortLogic) UpdatePort(req *types.UpdatePortReq) (resp *types.UpdatePortResp, err error) {
	// todo: add your logic here and delete this line
	UpdatePortReq := &openstack.UpdatePortReq{}
	err = copier.CopyWithOption(UpdatePortReq, req, copier.Option{Converters: utils.Converters})
	UpdatePortResp, err := l.svcCtx.OpenstackRpc.UpdatePort(l.ctx, UpdatePortReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdatePortResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdatePortResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
